VERSION 5.00
Begin VB.UserControl LSVLed 
   BackColor       =   &H00000000&
   CanGetFocus     =   0   'False
   ClientHeight    =   285
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   165
   PropertyPages   =   "LSVLed.ctx":0000
   ScaleHeight     =   19
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   11
   ToolboxBitmap   =   "LSVLed.ctx":0014
   Begin VB.Shape LED 
      BackColor       =   &H00008000&
      BackStyle       =   1  'Opaque
      BorderColor     =   &H00008000&
      Height          =   225
      Index           =   0
      Left            =   30
      Top             =   30
      Width           =   105
   End
End
Attribute VB_Name = "LSVLed"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "PropPageWizardRun" ,"Yes"
Option Explicit

' Standard Eigenschaftswerte:
Private Const m_def_LedStyle = 0
Private Const m_def_Value = 0
Private Const m_def_LedToLed = 1
Private Const m_def_LedsHeight = 15
Private Const m_def_LedsWidth = 6
Private Const m_def_Led1OffColor = &H8000&
Private Const m_def_Led2OffColor = &H8080&
Private Const m_def_Led3OffColor = &H80&
Private Const m_def_Led1OnColor = &HFF00&
Private Const m_def_Led2OnColor = &HFFFF&
Private Const m_def_Led3OnColor = &HFF&
Private Const m_def_Leds1 = 5
Private Const m_def_Leds2 = 3
Private Const m_def_Leds3 = 2

' Eigenschaft-Variablen:
Private m_LedStyle As enumLedStyle
Private m_Value As Integer
Private m_LedToLed As Integer
Private m_LedsHeight As Integer
Private m_LedsWidth As Integer
Private m_Led1OffColor As OLE_COLOR
Private m_Led2OffColor As OLE_COLOR
Private m_Led3OffColor As OLE_COLOR
Private m_Led1OnColor As OLE_COLOR
Private m_Led2OnColor As OLE_COLOR
Private m_Led3OnColor As OLE_COLOR
Private m_Leds1 As Integer
Private m_Leds2 As Integer
Private m_Leds3 As Integer

Private X As Integer
Private NV As Integer
Private OldNV As Integer

Private Sub LedNew()

    For X = 1 To LED.Count - 1

        Unload LED(X)

    Next X

    UserControl.Height = ((m_LedsHeight * (m_Leds1 + m_Leds2 + m_Leds3)) + ( _
        m_LedToLed * (m_Leds1 + m_Leds2 + m_Leds3 - 1))) * Screen.TwipsPerPixelY

    LED(0).Shape = m_LedStyle
    LED(0).Top = UserControl.ScaleHeight - m_LedsHeight
    LED(0).Left = 0
    LED(0).Height = m_LedsHeight
    LED(0).Width = m_LedsWidth
    LED(0).BackColor = m_Led1OffColor
    LED(0).BorderColor = m_Led1OffColor
    UserControl.Width = LED(0).Width * Screen.TwipsPerPixelX

    For X = 1 To m_Leds1 + m_Leds2 + m_Leds3 - 1

        Load LED(X)
        LED(X).Shape = m_LedStyle
        LED(X).Left = 0
        LED(X).Height = LED(0).Height
        LED(X).Width = LED(0).Width
        LED(X).Top = LED(X - 1).Top - LED(X - 1).Height - m_LedToLed

        If X = 1 And X <= m_Leds1 + 1 Then

            LED(X).BackColor = Led1OffColor
            LED(X).BorderColor = Led1OffColor

        End If

        If X > m_Leds1 - 1 And X <= m_Leds1 + m_Leds2 - 1 Then

            LED(X).BackColor = Led2OffColor
            LED(X).BorderColor = Led2OffColor

        End If

        If X > m_Leds1 + m_Leds2 - 1 Then

            LED(X).BackColor = Led3OffColor
            LED(X).BorderColor = Led3OffColor

        End If

        LED(X).Visible = True

    Next X

    NewValue

End Sub

Private Sub NewValue()

    NV = ((m_Leds1 + m_Leds2 + m_Leds3) * m_Value) \ 100

    For X = 0 To NV - 1

        If X <= m_Leds1 + 1 Then

            LED(X).BackColor = Led1OnColor
            LED(X).BorderColor = Led1OnColor

        End If

        If X > m_Leds1 - 1 And X <= m_Leds1 + m_Leds2 - 1 Then

            LED(X).BackColor = Led2OnColor
            LED(X).BorderColor = Led2OnColor

        End If

        If X > m_Leds1 + m_Leds2 - 1 Then

            LED(X).BackColor = Led3OnColor
            LED(X).BorderColor = Led3OnColor

        End If

        DoEvents

    Next X

    If NV < OldNV Then

        For X = m_Leds1 + m_Leds2 + m_Leds3 - 1 To NV Step -1

            If X <= m_Leds1 + 1 Then

                LED(X).BackColor = Led1OffColor
                LED(X).BorderColor = Led1OffColor

            End If

            If X > m_Leds1 - 1 And X <= m_Leds1 + m_Leds2 - 1 Then

                LED(X).BackColor = Led2OffColor
                LED(X).BorderColor = Led2OffColor

            End If

            If X > m_Leds1 + m_Leds2 - 1 Then

                LED(X).BackColor = Led3OffColor
                LED(X).BorderColor = Led3OffColor

            End If

            DoEvents

        Next X

    End If

    OldNV = NV

End Sub

Private Sub UserControl_Resize()

    UserControl.Width = (LED(0).Width * Screen.TwipsPerPixelX)

    UserControl.Height = ((m_LedsHeight * (m_Leds1 + m_Leds2 + m_Leds3)) + ( _
        m_LedToLed * (m_Leds1 + m_Leds2 + m_Leds3 - 1))) * Screen.TwipsPerPixelY

End Sub

Public Property Get Leds1() As Integer

    Leds1 = m_Leds1

End Property

Public Property Let Leds1(ByVal New_Leds1 As Integer)

    If New_Leds1 < 1 Then New_Leds1 = 1

    m_Leds1 = New_Leds1
    PropertyChanged "Leds1"
    LedNew

End Property

Public Property Get Leds2() As Integer

    Leds2 = m_Leds2

End Property

Public Property Let Leds2(ByVal New_Leds2 As Integer)

    If New_Leds2 < 0 Then New_Leds2 = 0

    m_Leds2 = New_Leds2
    PropertyChanged "Leds2"
    LedNew

End Property

Public Property Get Leds3() As Integer

    Leds3 = m_Leds3

End Property

Public Property Let Leds3(ByVal New_Leds3 As Integer)

    If New_Leds3 < 0 Then New_Leds3 = 0

    m_Leds3 = New_Leds3
    PropertyChanged "Leds3"
    LedNew

End Property

Private Sub UserControl_InitProperties()

    m_Leds1 = m_def_Leds1
    m_Leds2 = m_def_Leds2
    m_Leds3 = m_def_Leds3
    m_Led1OnColor = m_def_Led1OnColor
    m_Led2OnColor = m_def_Led2OnColor
    m_Led3OnColor = m_def_Led3OnColor
    m_Led1OffColor = m_def_Led1OffColor
    m_Led2OffColor = m_def_Led2OffColor
    m_Led3OffColor = m_def_Led3OffColor
    m_LedsHeight = m_def_LedsHeight
    m_LedsWidth = m_def_LedsWidth
    m_LedToLed = m_def_LedToLed
    m_Value = m_def_Value
    m_LedStyle = m_def_LedStyle

End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)

    m_Leds1 = PropBag.ReadProperty("Leds1", m_def_Leds1)
    m_Leds2 = PropBag.ReadProperty("Leds2", m_def_Leds2)
    m_Leds3 = PropBag.ReadProperty("Leds3", m_def_Leds3)
    m_Led1OnColor = PropBag.ReadProperty("Led1OnColor", m_def_Led1OnColor)
    m_Led2OnColor = PropBag.ReadProperty("Led2OnColor", m_def_Led2OnColor)
    m_Led3OnColor = PropBag.ReadProperty("Led3OnColor", m_def_Led3OnColor)
    m_Led1OffColor = PropBag.ReadProperty("Led1OffColor", m_def_Led1OffColor)
    m_Led2OffColor = PropBag.ReadProperty("Led2OffColor", m_def_Led2OffColor)
    m_Led3OffColor = PropBag.ReadProperty("Led3OffColor", m_def_Led3OffColor)
    m_LedsHeight = PropBag.ReadProperty("LedsHeight", m_def_LedsHeight)
    m_LedsWidth = PropBag.ReadProperty("LedsWidth", m_def_LedsWidth)
    m_LedToLed = PropBag.ReadProperty("LedToLed", m_def_LedToLed)
    m_Value = PropBag.ReadProperty("Value", m_def_Value)
    UserControl.BackColor = PropBag.ReadProperty("BackColor", &H0&)
    m_LedStyle = PropBag.ReadProperty("LedStyle", m_def_LedStyle)

End Sub

Private Sub UserControl_Show()

    LedNew

End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)

    Call PropBag.WriteProperty("Leds1", m_Leds1, m_def_Leds1)
    Call PropBag.WriteProperty("Leds2", m_Leds2, m_def_Leds2)
    Call PropBag.WriteProperty("Leds3", m_Leds3, m_def_Leds3)
    Call PropBag.WriteProperty("Led1OnColor", m_Led1OnColor, m_def_Led1OnColor)
    Call PropBag.WriteProperty("Led2OnColor", m_Led2OnColor, m_def_Led2OnColor)
    Call PropBag.WriteProperty("Led3OnColor", m_Led3OnColor, m_def_Led3OnColor)
    Call PropBag.WriteProperty("Led1OffColor", m_Led1OffColor, m_def_Led1OffColor)
    Call PropBag.WriteProperty("Led2OffColor", m_Led2OffColor, m_def_Led2OffColor)
    Call PropBag.WriteProperty("Led3OffColor", m_Led3OffColor, m_def_Led3OffColor)
    Call PropBag.WriteProperty("LedsHeight", m_LedsHeight, m_def_LedsHeight)
    Call PropBag.WriteProperty("LedsWidth", m_LedsWidth, m_def_LedsWidth)
    Call PropBag.WriteProperty("LedToLed", m_LedToLed, m_def_LedToLed)
    Call PropBag.WriteProperty("Value", m_Value, m_def_Value)
    Call PropBag.WriteProperty("BackColor", UserControl.BackColor, &H0&)
    Call PropBag.WriteProperty("LedStyle", m_LedStyle, m_def_LedStyle)

End Sub

Public Property Get Led1OnColor() As OLE_COLOR

    Led1OnColor = m_Led1OnColor

End Property

Public Property Let Led1OnColor(ByVal New_Led1OnColor As OLE_COLOR)

    m_Led1OnColor = New_Led1OnColor
    PropertyChanged "Led1OnColor"
    NewValue

End Property

Public Property Get Led2OnColor() As OLE_COLOR

    Led2OnColor = m_Led2OnColor

End Property

Public Property Let Led2OnColor(ByVal New_Led2OnColor As OLE_COLOR)

    m_Led2OnColor = New_Led2OnColor
    PropertyChanged "Led2OnColor"
    NewValue

End Property

Public Property Get Led3OnColor() As OLE_COLOR

    Led3OnColor = m_Led3OnColor

End Property

Public Property Let Led3OnColor(ByVal New_Led3OnColor As OLE_COLOR)

    m_Led3OnColor = New_Led3OnColor
    PropertyChanged "Led3OnColor"
    NewValue

End Property

Public Property Get Led1OffColor() As OLE_COLOR

    Led1OffColor = m_Led1OffColor

End Property

Public Property Let Led1OffColor(ByVal New_Led1OffColor As OLE_COLOR)

    m_Led1OffColor = New_Led1OffColor
    PropertyChanged "Led1OffColor"
    LedNew

End Property

Public Property Get Led2OffColor() As OLE_COLOR

    Led2OffColor = m_Led2OffColor

End Property

Public Property Let Led2OffColor(ByVal New_Led2OffColor As OLE_COLOR)

    m_Led2OffColor = New_Led2OffColor
    PropertyChanged "Led2OffColor"
    LedNew

End Property

Public Property Get Led3OffColor() As OLE_COLOR

    Led3OffColor = m_Led3OffColor

End Property

Public Property Let Led3OffColor(ByVal New_Led3OffColor As OLE_COLOR)

    m_Led3OffColor = New_Led3OffColor
    PropertyChanged "Led3OffColor"
    LedNew

End Property

Public Property Get LedsHeight() As Integer

    LedsHeight = m_LedsHeight

End Property

Public Property Let LedsHeight(ByVal New_LedsHeight As Integer)

    If New_LedsHeight < 1 Then New_LedsHeight = 1

    m_LedsHeight = New_LedsHeight
    PropertyChanged "LedsHeight"
    LedNew

End Property

Public Property Get LedsWidth() As Integer

    LedsWidth = m_LedsWidth

End Property

Public Property Let LedsWidth(ByVal New_LedsWidth As Integer)

    If New_LedsWidth < 1 Then New_LedsWidth = 1

    m_LedsWidth = New_LedsWidth
    PropertyChanged "LedsWidth"
    LedNew

End Property

Public Property Get LedToLed() As Integer

    LedToLed = m_LedToLed

End Property

Public Property Let LedToLed(ByVal New_LedToLed As Integer)

    If New_LedToLed < 0 Then New_LedToLed = 0

    m_LedToLed = New_LedToLed
    PropertyChanged "LedToLed"
    LedNew

End Property

Public Property Get Value() As Integer

    Value = m_Value

End Property

Public Property Let Value(ByVal New_Value As Integer)

    If New_Value < 0 Then New_Value = 0
    If New_Value > 100 Then New_Value = 100

    m_Value = New_Value
    PropertyChanged "Value"
    NewValue

End Property

Public Property Get BackColor() As OLE_COLOR

    BackColor = UserControl.BackColor

End Property

Public Property Let BackColor(ByVal New_BackColor As OLE_COLOR)

    UserControl.BackColor() = New_BackColor
    PropertyChanged "BackColor"

End Property

Public Property Get LedStyle() As enumLedStyle

    LedStyle = m_LedStyle

End Property

Public Property Let LedStyle(ByVal New_LedStyle As enumLedStyle)

    m_LedStyle = New_LedStyle
    PropertyChanged "LedStyle"

    For X = 0 To LED.Count - 1

        LED(X).Shape = m_LedStyle

    Next X

End Property

